package org.apache.commons.lang3.function;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.util.Objects;

public interface FailableDoubleUnaryOperator<E extends Throwable> {
  public static final org.apache.commons.lang3.function.FailableDoubleUnaryOperator NOP = t -> 0.0D;
  
  static <E extends Throwable> org.apache.commons.lang3.function.FailableDoubleUnaryOperator<E> identity() {
    return t -> t;
  }
  
  static <E extends Throwable> org.apache.commons.lang3.function.FailableDoubleUnaryOperator<E> nop() {
    return NOP;
  }
  
  default org.apache.commons.lang3.function.FailableDoubleUnaryOperator<E> andThen(org.apache.commons.lang3.function.FailableDoubleUnaryOperator<E> after) {
    Objects.requireNonNull(after);
    return t -> after.applyAsDouble(applyAsDouble(t));
  }
  
  default org.apache.commons.lang3.function.FailableDoubleUnaryOperator<E> compose(org.apache.commons.lang3.function.FailableDoubleUnaryOperator<E> before) {
    Objects.requireNonNull(before);
    return v -> applyAsDouble(before.applyAsDouble(v));
  }
  
  double applyAsDouble(double paramDouble) throws E;
}
